/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
#ifndef NS_CODE_H
#define NS_CODE_H

#include "global.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Number of bytes a SHA-1 hash produces
 */
#define SHA1_LENGTH	20

/*
 * Estimate the length of base64 encoded string
 */
#define BASE64_LEN(vlen)        (((vlen) * 4 / 3 ) + 3)

/*
** SHA-1 secure hash function
*/

/*
** Hash a null terminated character string "src" into "dest" using SHA-1
*/
static int SHA1_Hash(unsigned char *dest, char *src);

/*
** Hash a non-null terminated string "src" into "dest" using SHA-1
*/
static int SHA1_HashBuf(unsigned char *dest, unsigned char *src,
			     unsigned int src_length);

NSAPI_EXTERN int base64_decode( char *src, unsigned char *dst );

NSAPI_EXTERN int base64_encode( unsigned char *src, char *dst, int srclen, int lenused );

NSAPI_EXTERN char *sha1_pw_enc( char *pwd );

NSAPI_EXTERN int sha1_pw_cmp( char *userpwd, char *dbpwd );

#ifdef __cplusplus
}
#endif

#endif
