/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
/**********************************************************************
**
** NAME
**   nsdefs.h
**
** DESCRIPTION
**   General C++ classes needed but not generally available
**
** NOTES
**
** HISTORY
**
** $Log: nsdefs.h,v $
** Revision 1.1.1.1  2005/07/29 22:16:28  foxworth
** Importing new setup sdk for open source project
**
** Revision 1.5  2005/07/29 19:43:26  nkinder
** 164436 - Updated copyrights, licensed code under LGPL, and licensed docs under OPL
**
** Revision 1.4  2005/07/27 03:01:38  nhosoi
** [161408] Open Sourcing Setup Util
** Replacing "#include <iostream>" with "#include <iostream.h>" for HP-UX.
**
** Revision 1.3  2005/07/27 01:04:49  nhosoi
** [161408] Open Sourcing Setup Util
** 1) Setup SDK -> Setup Util
** 2) Fixed doc to adjust to the current status (including branding -- debranding Netscape)
** 3) Eliminated to reference to unzip code and libwww (plus downloader, which uses libwww)
** 4) Added unzip_wrapper.pl which calls unzip command line utility (assuming installed on the system), which does the equivalent to the modified unzip code.
** 5) code cleanup
**
** Revision 1.2  2005/03/01 01:45:12  nhosoi
** Brand the Setup SDK as "Fedora"; updated copyrights
**
** Revision 1.1.1.1  2005/01/25 18:34:45  cvsadm
** Move SetupSDK from 6.2 development branch to TRUNK
**
** Revision 1.1.1.3  2001/11/06 01:51:27  ahakim
** XXX AOL/NSCP Copyright XXX
**
** Revision 1.1.1.2  1999/09/28 18:16:55  cxue
** Linux compilation warning
**
** Revision 1.1.1.1  1999/03/04 23:26:56  svbld
** importing setupsdk41 closer to the trunk
**
** Revision 1.1.2.27.8.4  1998/11/11 00:55:59  cxue
** HP compiler is happy now
**
** Revision 1.1.2.27.8.3  1998/11/03 21:18:33  cxue
** NVPair.set takes int and unsigned int
**
** Revision 1.1.2.27.8.2  1998/10/15 22:20:59  cxue
** add setupdefs.h
**
** Revision 1.1.2.27.8.1  1998/09/25 23:09:44  cxue
** NVPair::set to take unsigned long value
**
** Revision 1.1.2.27  1998/06/05 03:37:20  pvo
** 118281 - additional code for UTF8 conversion
**
** Revision 1.1.2.26  1998/05/28 21:15:00  pvo
** 122386 - add i18n_isspace()
**
** Revision 1.1.2.25  1998/04/20 20:51:30  pvo
** 112701 - problem reconfiguring SIE
**
** Revision 1.1.2.24  1998/04/09 23:57:48  pvo
** Restructure ux-util.h
**
** Revision 1.1.2.23  1998/03/28 03:27:43  pvo
** 103621 - Support for 8-bit input.
**
** Revision 1.1.2.22  1998/03/04 02:28:44  pvo
** Added support for ldif line continuation and common time format.
**
** Revision 1.1.2.21  1998/02/26 01:40:22  gbeasley
** more sie integration
**
** Revision 1.1.2.20  1998/02/24 01:05:20  pvo
** Initial setup for integrating UX and NT SIE functions.
**
** Revision 1.1.2.19  1998/02/24 00:40:23  pvo
** Change to support change from globals.{h,cpp} to global.{h, cpp}
**
** Revision 1.1.2.18  1998/01/09 03:23:35  pvo
** Added a couple of set/add functions that operate on NVPair's section
** and fixed problem with ux_time_stamp().
**
** Revision 1.1.2.17  1997/11/26 02:05:07  pvo
** Added NVPair::read
**
** Revision 1.1.2.16  1997/11/15 04:55:15  pvo
** Fixed memory leak problems. Redo contatenation operation for NSString.
**
** Revision 1.1.2.15  1997/11/09 19:25:27  pvo
** Name changes for some APIs to be more meaningful. Added freeListItems.
**
** Revision 1.1.2.14  1997/11/07 22:42:46  pvo
** New code to support uninstallation.
**
** Revision 1.1.2.13  1997/10/24 03:39:25  pvo
** Final modification to make all work across platforms! Hope I make
** it this time.
**
** Revision 1.1.2.12  1997/10/23 03:23:25  pvo
** More change to support other platforms.
**
** Revision 1.1.2.11  1997/10/22 23:58:12  pvo
** Cross platform stuffs.
**
** Revision 1.1.2.10  1997/10/16 04:24:06  pvo
** Quite a lot of code changes for support updating and ACIs.
**
** Revision 1.1.2.9  1997/10/14 05:01:49  pvo
** More code.
**
** Revision 1.1.2.8  1997/10/10 00:37:31  pvo
** Resolved conflicts in name space with zip library.
**
** Revision 1.1.2.7  1997/10/06 21:06:38  pvo
** Additional code. Pirated routine time_stamp from util_ctime.
**
** Revision 1.1.2.6  1997/09/27 02:46:40  pvo
** Checked in.
**
***********************************************************************/

#ifndef NS_DEFS_H
#define NS_DEFS_H

/**********************************************************************
**
** Includes
**
**********************************************************************/
#include <iostream.h>

#ifdef XP_WIN32
#include <stdlib.h>
#include <sys/stat.h>
#else
extern "C" {
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
}
#endif

#include "setupdefs.h"
#include "global.h"

/*
***********************************************************************
** CLASS:
**   NSString
**
** DESCRIPTION:
**   String class
**
***********************************************************************
*/
class NSStringRep;

class NSString
{
public:
   ///////////////////////////////////////////////////////////////////
   // Default constructor - construct an empty NSString
   ///////////////////////////////////////////////////////////////////
   NSString();

   ///////////////////////////////////////////////////////////////////
   // Construct String from s
   ///////////////////////////////////////////////////////////////////
   NSString(const char *s);

   ///////////////////////////////////////////////////////////////////
   // Construct String from s using upto length chars
   ///////////////////////////////////////////////////////////////////
   NSString(const char *s, int length);

   ///////////////////////////////////////////////////////////////////
   // Copy constructor
   ///////////////////////////////////////////////////////////////////
   NSString (const NSString &);

   virtual ~NSString();

   ///////////////////////////////////////////////////////////////////
   // Assignment
   ///////////////////////////////////////////////////////////////////
   NSString & operator = (const char *);
   NSString & operator = (const NSString &);

   ///////////////////////////////////////////////////////////////////
   // Comparison
   ///////////////////////////////////////////////////////////////////
   int operator == (const char *m) const;
   int operator != (const char *m) const;
   int operator == (const NSString & m) const;
   int operator != (const NSString & m) const;

   ///////////////////////////////////////////////////////////////////
   // Get char * from string
   ///////////////////////////////////////////////////////////////////
   virtual const char *data() const
      { return _data; }
   operator const char * () const
      { return _data; }

   virtual long length() const
      { return _length; }

protected:

   void init(const char *s, int length);
   void clear();

   // Append constructor
   NSString (const char *s1, long l1, const char *s2, long l2);

private:

   NSStringRep* _rep;

   // Following are only for convenience, not really required
   char *_data;
   long _length;
   void assign (const NSString &s);

///////////////////////////////////////////////////////////////////
// The real stuffs - concatination functions
///////////////////////////////////////////////////////////////////

friend NSString
operator + (const NSString &, const NSString &);

friend NSString
operator + (const char *, const NSString &);

friend NSString
operator + (const NSString &, const char *);

};


/*
***********************************************************************
** CLASS:
**   NVPair
**
** DESCRIPTION:
**   Name Value Pair
**
** NOTE:
**
***********************************************************************
*/

typedef void * NVPairImp;

class NVPair
{
public:

   ///////////////////////////////////////////////////////////////////
   //// Public Constructor/Deconstructor
   ///////////////////////////////////////////////////////////////////
   NVPair();
   NVPair(const char *fileName);
   NVPair(const NVPair &);

   ~NVPair();

   ///////////////////////////////////////////////////////////////////
   //// read
   ///////////////////////////////////////////////////////////////////
   void read(const char *fileName);

   ///////////////////////////////////////////////////////////////////
   //// isEmpty
   ///////////////////////////////////////////////////////////////////
   Bool isEmpty() const;

   ///////////////////////////////////////////////////////////////////
   //// clear: empty out this Name/Value pair
   ///////////////////////////////////////////////////////////////////
   void clear();

   ///////////////////////////////////////////////////////////////////
   //// Assignment operators
   ///////////////////////////////////////////////////////////////////
   NVPair & operator = (const NVPair &);

   ///////////////////////////////////////////////////////////////////
   //// Get the ID of this NVPair.
   //// In general, the ID is not set but
   //// when a "section" the NVPair associated
   //// with the section takes on the section
   //// name as the ID.
   ///////////////////////////////////////////////////////////////////
   const char *id () const
     { return _id; }

   void id (const char *id);

   ///////////////////////////////////////////////////////////////////
   //// Put a timestamp on this block
   ///////////////////////////////////////////////////////////////////
   const char *timeStamp() const;
   void stampTime();

   //// name/value pair get/set functions//////

   ///////////////////////////////////////////////////////////////////
   //// get the value string associated with name
   ///////////////////////////////////////////////////////////////////
   const char *get(const char *name) const;

   ///////////////////////////////////////////////////////////////////
   //// set the value of name to "value". If "name" does not exist
   //// it will be created. If name already exists, its value will
   //// be overwritten.
   ///////////////////////////////////////////////////////////////////
   void  set(const char *name, const char *value);
   void  set(const char *name, const NSString &value);
   void  set(const char *name, int value);
   void  set(const char *name, unsigned int value);
   void  set(const char *name, long value);
   void  set(const char *name, unsigned long value);

   void  set(const char *section, const char *name, const char *value);
   void  set(const char *section, const char *name, const NSString &value);
   void  set(const char *section, const char *name, long value);

   ///////////////////////////////////////////////////////////////////
   //// "List" functions. A list is just a name containing multivalues
   ////   getListItem: get the n-th value in list "name"
   ////   getListItems: get all the values in list "name". Use
   ////     freeListItems() to to discard it after use.
   ///////////////////////////////////////////////////////////////////
   const char *getListItem (const char *name, int nth) const;
   char **getListItems(const char *name) const;
   static void freeListItems(char **items);

   ///////////////////////////////////////////////////////////////////
   //// Does list "name" contain value?
   ///////////////////////////////////////////////////////////////////
   Bool  inList(const char *name, const char *value) const;

   ///////////////////////////////////////////////////////////////////
   //// Does list exist ?
   ///////////////////////////////////////////////////////////////////
   Bool  listExists(const char *name) const;

   ///////////////////////////////////////////////////////////////////
   //// Add "value" to list. If list does not exist, it will be created.
   ////
   ///////////////////////////////////////////////////////////////////
   void add (const char *list, const char *value);
   void add (const char *list, const NSString &value);
   void add (const char *list, const char **values);

   void add (const char *section, const char *list, const char *value);
   void add (const char *section, const char *list, const NSString &value);
   void add (const char *section, const char *list, const char **values);

   ///////////////////////////////////////////////////////////////////
   //// Delete a list
   ///////////////////////////////////////////////////////////////////
   void  delList(const char *name);
   void  delListItem(const char *name, const char *item);

   ///////////////////////////////////////////////////////
   //// Name Traversal functions
   ///////////////////////////////////////////////////////
   int numName() const;
   int numList() const;
   int numListItems(const char *list) const;

   ///////////////////////////////////////////////////////
   //// Get the n-th "name" as stored in NVPair
   ///////////////////////////////////////////////////////
   const char *name(int nth) const;

   ///////////////////////////////////////////////////////
   //// Get the name of list n-th as stored in NVPair
   ///////////////////////////////////////////////////////
   const char *list(int nth) const;

   ///////////////////////////////////////////////////////
   //// Get the number of the sub-Name/Value pairs
   ///////////////////////////////////////////////////////
   int numSections () const;

   ///////////////////////////////////////////////////////
   //// Get the n-th sub-NVPair
   ///////////////////////////////////////////////////////
   NVPair * getSection(int nth);

   ///////////////////////////////////////////////////////
   //// Get the sub-NVPair identified by "name"
   ///////////////////////////////////////////////////////
   NVPair * getSection(const char *name);

   ///////////////////////////////////////////////////////
   //// Add subBlock into this NVPair as a sub-NVPair.
   //// If the subBlock does not exist, it will be created
   //// Otherwise the new one will merge with the old one.
   ///////////////////////////////////////////////////////
   void addSection(const char *name, NVPair *subBlock);

   ///////////////////////////////////////////////////////
   //// Create a section in the current NVPair if none
   //// exists yet and returns a pointer to the section
   ///////////////////////////////////////////////////////
   NVPair *createSection(const char *name);

   ///////////////////////////////////////////////////////
   //// Rename a "name"
   ///////////////////////////////////////////////////////
   void rename(const char *oldLabel, const char *newLabel);

   ///////////////////////////////////////////////////////
   //// Delete a name/value. Use delList to delete list
   ///////////////////////////////////////////////////////
   void remove(const char *label);

   ///////////////////////////////////////////////////////
   //// I18n conversion function
   ////  - Specifying label will perform the conversion
   ////    on that label only. Otherwise, the whole
   ////    NVPair structure will be converted
   ///////////////////////////////////////////////////////
   void toUTF8(const char *label=0);
   void toLocal(const char *label=0);

   ///////////////////////////////////////////////////////
   //// Write this block out to fileName in the format
   //// specified via setFormat().
   ///////////////////////////////////////////////////////
   int write(const char *fileName) const;

   ///////////////////////////////////////////////////////
   //// Write this block out to the file from which it
   //// was read from previously. Return -1 if error.
   ///////////////////////////////////////////////////////
   int write() const;

   ///////////////////////////////////////////////////////
   // Set the delimeters for name/value pairs in the written file
   // Should be called before write()
   //   which = 0 - <sp> for name/value, ':" for list
   //   which = 1 - '='
   //   which = 2 - ':'
   ///////////////////////////////////////////////////////

   void setFormat(int which);

protected:
   void init(const char *fileName = NULL);

private:
   Bool _removable;
   NVPairImp *_block;
   NSString _id;
   char *_fileName;
   int _format;
};

typedef NVPair InstallInfo;

/*
 * Miscellaneous functions
 */
extern "C" {
NSAPI_EXTERN void get_gmtime(char *buf, int buflen);
}

#endif
