/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
/*********************************************************************
*
** NAME
**   utf8.h
**
** DESCRIPTION
**   Utilities to convert from UTF-8 to local encoding and vice versa.
** NOTES
**
** HISTORY
** $Log: utf8.h,v $
** Revision 1.1.1.1  2005/07/29 22:16:28  foxworth
** Importing new setup sdk for open source project
**
** Revision 1.3  2005/07/29 19:43:26  nkinder
** 164436 - Updated copyrights, licensed code under LGPL, and licensed docs under OPL
**
** Revision 1.2  2005/03/01 01:45:12  nhosoi
** Brand the Setup SDK as "Fedora"; updated copyrights
**
** Revision 1.1.1.1  2005/01/25 18:34:45  cvsadm
** Move SetupSDK from 6.2 development branch to TRUNK
**
** Revision 1.1.1.2.4.1  2002/12/02 20:11:33  djani
** Elimination of libNLS from setupsdk
**
** Revision 1.1.1.2  2001/11/06 01:51:29  ahakim
** XXX AOL/NSCP Copyright XXX
**
** Revision 1.1.1.1  1999/03/04 23:26:58  svbld
** importing setupsdk41 closer to the trunk
**
** Revision 1.1.4.4.4.2  1998/11/11 20:22:03  gbeasley
** isAsciibuffer
**
** Revision 1.1.4.4.4.1  1998/10/15 22:20:59  cxue
** add setupdefs.h
**
** Revision 1.1.4.4  1998/08/20 20:02:30  gbeasley
** admin domain change
**
** Revision 1.1.4.3  1998/04/24 17:23:28  gbeasley
** unix and nt use nsSetupFree
**
** Revision 1.1.2.3  1998/04/23 01:04:37  pvo
** Make NssetupFree shared between Unix and NT
**
** Revision 1.1.2.2  1998/04/20 23:28:21  gbeasley
** fix memory leak
**
** Revision 1.1.4.2  1998/03/28 03:34:33  pvo
** Include global.h.
**
** Revision 1.1.4.1  1998/03/28 03:27:44  pvo
** 103621 - Support for 8-bit input.
**
*********************************************************************/

#ifndef _UTF8_H
#define _UTF8_H

#include "setupdefs.h"
#include "global.h"

#ifdef __cplusplus
extern "C" {
#endif

NSAPI_EXTERN char * UTF8ToLocal(const char *utf8);
NSAPI_EXTERN char * localToUTF8(const char *src);
NSAPI_EXTERN int  isAsciiBuffer(const char *src);

#ifndef TRUE
#  define TRUE      1   /* sort of obvious */
#endif
#ifndef FALSE
#  define FALSE     0
#endif

#ifdef __cplusplus
}
#endif

#endif
