/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
#include "stdio.h"
#include "string.h"

#ifndef WIN32
#include "nsdefs.h"
#endif

int
main(int argc, char **argv)
{
#ifndef WIN32
   NVPair *nv;
   const char *s;
   int n;
   int i;
   NVPair *section;
   char *filename;

   if (argc < 2) {
      printf("program filename\n");
      exit(0);
   }

   filename = strdup(argv[1]);
   nv = new NVPair(argv[1]);

   n = nv->numSections();
   printf("number of sections = %d\n", n);
   
   printf("section name =\n");
   for (i = 0; i < n; i++) {      
      section = nv->getSection(i);
      printf(" [%d] = %s\n", i, section->id());
   }

   printf("General = \n");
   printf(" = %s\n", nv->get("Components"));
#endif

   return 0;

}
