/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation version
 * 2.1 of the License.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/
/**********************************************************************
** NAME
**   wizard.h
**
** DESCRIPTION
**
** NOTES
**
** HISTORY
**
** $Log: wizard.h,v $
** Revision 1.1.1.1  2005/07/29 22:16:32  foxworth
** Importing new setup sdk for open source project
**
** Revision 1.3  2005/07/29 19:43:29  nkinder
** 164436 - Updated copyrights, licensed code under LGPL, and licensed docs under OPL
**
** Revision 1.2  2005/03/01 01:45:17  nhosoi
** Brand the Setup SDK as "Fedora"; updated copyrights
**
** Revision 1.1.1.1  2005/01/25 18:34:45  cvsadm
** Move SetupSDK from 6.2 development branch to TRUNK
**
** Revision 1.1.1.1  1999/03/04 23:27:10  svbld
** importing setupsdk41 closer to the trunk
**
** Revision 1.1.2.7  1997/12/12 21:54:25  pvo
** Various bug fixes.
**
** Revision 1.1.2.6  1997/11/26 02:03:04  pvo
** Restructure files and add Download support.
**
** Revision 1.1.2.5  1997/11/08 16:52:04  pvo
** UnInstallation support.
**
** Revision 1.1.2.4  1997/10/22 02:40:51  pvo
** Too many changes to list out here.
**
** Revision 1.1.2.3  1997/09/27 02:47:21  pvo
** Checked in.
**
***********************************************************************/

#ifndef NS_WIZARD_H
#define NS_WIZARD_H
/*
 * Includes
 */
#include "nsdefs.h"
#include "ux-util.h"
#include "dialog.h"
#include "ux-setup.h"

/*
 * Forward References
 */

#define MAX_DIALOGS 120

class SetUp;

class Wizard:public DialogManager
{
public:
   Wizard()
     :_lastDialog(-1),_currentDialog(-1), _parent(0)
     {}

   ~Wizard()
     {}

   /*
    * Start the wizard manager 
    */
   int start();

   int cont();

   void add(Dialog *p);

   void addLast(Dialog *p);

   void resetLast();

   void clear();

   void setParent (void *parent)
     { _parent = (SetUp *) parent; }
   void *parent() const
     { return _parent; }

private:

   Dialog *_myDialogs[MAX_DIALOGS];
   /*
    * Current dialog
    */
   int _currentDialog;

   int _lastDialog;

   SetUp *_parent;

   int startDialog(int which);
};

#endif
